//<head>//////////////////////////////////////////////////////////////
//
//	
//	Lexed version 4.0
//	Copyright (C) 1999 2000 2001 2002 2003.
//	Universit Paris 7
//	INRIA Rocquencourt
//
//	Conception & programmation :
//	Lionel Clment
//	e-mail : lionel.clement@linguist.jussieu.fr
//
//	vendredi 18 janvier 2002, 13h41
//
//
////////////////////////////////////////////////////////////////</head>////

#ifndef LEMMETREE_H
#define LEMMETREE_H

#define BUG {fprintf (stderr, "*** Bug %s(%d)\n", __FILE__, __LINE__);}

typedef unsigned long int TYPEPTR;

#define MAXSTRING 4096
#define MAXREPLACE 1024

#include "lexedtcp.h"
#include "lexedinfo.h"

struct FindReplaceStructure {
  char *Find;
  char *Repl;
};

////////////////////////////////////////////////////////////
//
////////////////////////////////////////////////////////////
int
SaveFSA(FILE *Fichier);

////////////////////////////////////////////////////////////
//
////////////////////////////////////////////////////////////
int
LoadFSA(FILE *Fichier);

void ApproxStatic(int ClientServer, 
		  TcpServer server, 
		  TYPEPTR Index,
		  char *Chaine,
		  int NbreApproxErase, int NbreApproxSubstitute, int NbreApproxAdd,
		  char *,
		  int,
		  int);


////////////////////////////////////////////////////////////
// input: chaine
// output: info
////////////////////////////////////////////////////////////
TYPEPTR TrouverStatic(TYPEPTR Index,
		      char *Chaine);

////////////////////////////////////////////////////////////
// input: chaine
// output: affichage des infos ou envoie au client
////////////////////////////////////////////////////////////
void OutStatic(int ClientServer, 
	       TcpServer server, 
	       char *Chaine);

class Fsa1 {
  public:
  TYPEPTR fils;
  int car;
} ;

class Fsa2 {
  public:
  TYPEPTR frere;
  int car;
} ;

class Fsa3 {
  public:
  TYPEPTR fils;
  TYPEPTR frere;
  int car;
} ;

class Fsa4 {
  public:
  TYPEPTR info;
  int car;
} ;

class Fsa5 {
  public:
  TYPEPTR fils;
  TYPEPTR info;
  int car;
} ;

class Fsa6 {
  public:
  TYPEPTR frere;
  TYPEPTR info;
  int car;
} ;

class Fsa7 {
  public:
  TYPEPTR fils;
  TYPEPTR frere;
  TYPEPTR info;
  int car;
} ;

class Arbre
{
  Arbre *fils;
  Arbre *frere;
  Info *info;
  int car;

public:
  
  TYPEPTR adress;
  
  Arbre(Arbre *Fils,
	Arbre *Frere,
	Info *Info,
	unsigned int Car)
    {
      adress=0;
      fils = Fils;
      frere = Frere;
      info = Info;
      car = Car;
    };
  
  ~Arbre() {};

  void Ajouter(char *, 
	       TYPEPTR);
  void SetIndexStaticFSA(unsigned long int &, unsigned char);
  void PrintStaticFSA(FILE *, unsigned char);
  void SetIndexStaticInfo(unsigned long int &, unsigned char);
  void PrintStaticInfo(FILE *, unsigned char);
};

#endif // LEMMETREE_

